import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * AppleWorld is an example of a scrolling world.
 * 
 * @author BenMcBen
 * @version 10/26/2014
 */
public class AppleWorld extends ScrollingWorld {
    /**
     * Constructor for objects of class AppleWorld.
     * 
     */
    public AppleWorld() {
        super();
        makeBackground();
        populate();
    }
    /**
     * populate - HORP DORP APPLES
     * dee durp dee doop
     */
    public void populate() {
        for (int i = 0; i < 200; i++) {
            // Notice that everything we would normally do to the world proper, we're doing to
            // getUnderlying(). This is because getUnderlying() is our real world here. The
            // ScrollingWorld is really just the screen.
            getUnderlying().addObject(new Apple(),
                                      Greenfoot.getRandomNumber(getUnderlying().getWidth()),
                                      Greenfoot.getRandomNumber(getUnderlying().getHeight()));
        }
        for (int x = 0; x < getUnderlying().getWidth()/300; x++) {
            for (int y = 0; y < getUnderlying().getHeight()/300; y++) {
                // this will make a grid of bugs
                // for the funs
                getUnderlying().addObject(new Dot(), x*300, y*300);
            }
        }
    }
    /**
     * checkKeyPress - scroll on command
     */
    public void checkKeyPress() {
        if (Greenfoot.isKeyDown("left")) {
            scroll(-5, 0);
        }
        if (Greenfoot.isKeyDown("right")) {
            scroll(5, 0);
        }
        if (Greenfoot.isKeyDown("up")) {
            scroll(0, -5);
        }
        if (Greenfoot.isKeyDown("down")) {
            scroll(0, 5);
        }
    }
    /**
     * act - do the things
     */
    public void act() {
        checkKeyPress();
        super.act(); // call the super.act() at the end since it updates the screen
    }
    /**
     * makeBackground - make a snazzy background
     */
    public void makeBackground() {
        // This is where we use the persistentBackground getter and setter.
        GreenfootImage bg = getPersBackground();
        bg.setColor(Color.black);
        bg.fill();
        bg.setColor(Color.white);
        for (int i = 0; i < 60; i++) {
            bg.fillOval(Greenfoot.getRandomNumber(bg.getWidth()),
                        Greenfoot.getRandomNumber(bg.getHeight()),
                        2, 2);
        }
        setPersBackground(bg); // this is redundant but whatever
    }
}
